<template>
  <v-container fluid class="pt-0">
    <v-row v-if="!category" no-gutters id="search-field">
      <v-col>
        <SearchFieldDark init-query="Все полезные дела"/>
      </v-col>
    </v-row>
    <v-row id="places">
      <v-col>
        <template v-if="!projects || categoriesLoadStatus === 'loading'">
          <div
            v-for="n in 2"
            :key="n"
            class="mt-4 mb-2"
          >
            <v-skeleton-loader
              class="mb-5"
              transition="scale-transition"
              type="heading"
              width="300"
            ></v-skeleton-loader>
            <v-skeleton-loader
              v-for="l in 3"
              :key="l"
              class="mb-2"
              transition="scale-transition"
              type="card-heading"
            ></v-skeleton-loader>
          </div>
        </template>
        <template v-else-if="categoriesLoadStatus === 'success'">
          <template v-if="!category">
            <div
              class="category-places"
              v-for="(category, index) in projects"
              :key="index"
            >
              <Places :title="category.name" :places="category.projects"/>
            </div>
          </template>
          <Places v-else :title="categories[+category - 1].name" :places="projects"/>
        </template>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
  import SearchFieldDark from '../components/SearchFieldDark';
  import Places from '../components/Places';
  import {mapState} from 'vuex';
  import api from '../api';

  export default {
    name: 'Projects',
    components: {SearchFieldDark, Places},
    data: function() {
      return {
        projects: null,
        category: this.$route.query.category || null,
      };
    },
    computed: {
      ...mapState('categories', [
        'categories',
        'categoriesLoadStatus',
      ]),
    },
    async created() {
      if (this.category) {
        if (this.category < 1) return;
        this.projects = await api.getCategoryProjects(this.category);
        return;
      }

      this.projects = await this.$store.dispatch('categories/getCategoriesWithProjects');
    },
  };
</script>

<style scoped>
</style>
